package by.zerg.wtp.domain;

import java.io.File;
import java.io.FileInputStream;
import java.util.Properties;

import by.zerg.wtp.exception.ConfigNotFoundException;

public class Config {
	final String loginUrl;
	final String postUrl;
	final String convertUrl;
	final String username;
	final String password;
	final String redirect;
	final String login;
	final String handpot;
	final String df83;

	static Config instance;

	private Config() throws ConfigNotFoundException {
		try {
			Properties props = new Properties();
			props.load(new FileInputStream("conf" + File.separator
					+ "config.properties"));
			this.loginUrl = props.getProperty("loginUrl");
			this.postUrl = props.getProperty("postUrl");
			this.convertUrl = props.getProperty("convertUrl");
			this.username = props.getProperty("username");
			this.password = props.getProperty("password");
			this.redirect = props.getProperty("redirect");
			this.login = props.getProperty("login");
			this.handpot = props.getProperty("handpot");
			this.df83 = props.getProperty("df83");
		} catch (Throwable t) {
			throw new ConfigNotFoundException("config not found");
		}
	}

	public static void load() throws ConfigNotFoundException {
		instance = new Config();
	}

	public static Config getInstance() {
		return instance;
	}

	public String getLoginUrl() {
		return loginUrl;
	}

	public String getPostUrl() {
		return postUrl;
	}

	public String getConvertUrl() {
		return convertUrl;
	}

	public String getUsername() {
		return username;
	}

	public String getPassword() {
		return password;
	}

	public String getRedirect() {
		return redirect;
	}

	public String getLogin() {
		return login;
	}

	public String getHandpot() {
		return handpot;
	}

	public String getDf83() {
		return df83;
	}
}
