package by.zerg.wtp.gui;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.JTextField;

public class FiltersPanel extends JPanel {
	JButton applyButton;
	JButton skipButton;
	JCheckBox selectAllCheckbox;
	JCheckBox publicAllCheckbox;
	JComboBox potFilterCombo;
	JTextField potFilterField;

	public FiltersPanel(final MainFrame mainFrame) {
		selectAllCheckbox = new JCheckBox();
		selectAllCheckbox.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				// TODO Auto-generated method stub
				for (HandPanel p : mainFrame.handsPanels) {
					p.selectedCheckbox.setSelected(selectAllCheckbox
							.isSelected());
				}
			}

		});

		publicAllCheckbox = new JCheckBox();
		publicAllCheckbox.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				// TODO Auto-generated method stub
				for (HandPanel p : mainFrame.handsPanels) {
					p.publicCheckbox.setSelected(publicAllCheckbox.isSelected());
				}
			}

		});

		potFilterCombo = new JComboBox(new String[] { "<", ">", "=" });

		potFilterField = new JTextField(4);

		applyButton = new JButton("apply");
		applyButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				// TODO Auto-generated method stub
				for (HandPanel p : mainFrame.handsPanels) {
					boolean flag = false;
					double potPattern = Double.parseDouble(potFilterField
							.getText());
					double pot = Double.parseDouble(p.hand.getPot().replaceAll(
							"[^\\d.]", ""));
					switch (potFilterCombo.getSelectedIndex()) {
					case 0:
						flag = pot <= potPattern;
						break;
					case 1:
						flag = pot >= potPattern;
						break;
					case 2:
						flag = pot == potPattern;
						break;
					}
					p.setVisible(flag);
				}
			}

		});

		skipButton = new JButton("skip");
		skipButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				for (HandPanel p : mainFrame.handsPanels) {
					p.setVisible(true);
				}
				potFilterCombo.setSelectedIndex(0);
				potFilterField.setText(null);
			}

		});

		setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.NONE;
		c.anchor = GridBagConstraints.WEST;
		c.insets = new Insets(5, 5, 5, 5);
		add(selectAllCheckbox, c);
		add(publicAllCheckbox, c);
		c.fill = GridBagConstraints.VERTICAL;
		add(new JSeparator(JSeparator.VERTICAL), c);
		c.fill = GridBagConstraints.NONE;
		add(new JLabel("Pot: "), c);
		add(potFilterCombo, c);
		add(potFilterField, c);
		c.fill = GridBagConstraints.VERTICAL;
		add(new JSeparator(JSeparator.VERTICAL), c);
		add(applyButton, c);
		add(skipButton, c);
		c.weightx = 1;
		add(new JLabel(), c);
	}
}
