package by.zerg.wtp.log;

import java.io.IOException;

import org.apache.log4j.FileAppender;
import org.apache.log4j.Layout;
import org.apache.log4j.spi.ErrorCode;

public class MultipleLogFilesAppender extends FileAppender {

	public MultipleLogFilesAppender() {
	}

	public MultipleLogFilesAppender(Layout layout, String filename,
			boolean append, boolean bufferedIO, int bufferSize)
			throws IOException {
		super(layout, filename, append, bufferedIO, bufferSize);
	}

	public MultipleLogFilesAppender(Layout layout, String filename,
			boolean append) throws IOException {
		super(layout, filename, append);
	}

	public MultipleLogFilesAppender(Layout layout, String filename)
			throws IOException {
		super(layout, filename);
	}

	@Override
	public void activateOptions() {
		try {
			fileName = getNewLogFileName();
			setFile(fileName, fileAppend, bufferedIO, bufferSize);
		} catch (Exception e) {
			errorHandler.error("error when activating log options", e,
					ErrorCode.FILE_OPEN_FAILURE);
		}
	}

	private String getNewLogFileName() {
		String result = null;
		if (fileName != null) {
			result = fileName.replace("%", "" + System.currentTimeMillis());
		}
		return result;
	}
}
